// pagrind. tipai ir dalykai

#ifndef __TIPAI__
#define __TIPAI__

#if defined __cplusplus
extern "C"
{
#endif

int abs(int);

#ifdef TGT_LIN
#include <unistd.h>
#define pause(msec) usleep((msec))
#else
#include <time.h>
#define pause(msec) delay((msec))
#endif

typedef unsigned char uchar;     // 0..255
typedef signed char   schar;     // -128..127

#if !defined __USE_MISC
typedef unsigned short ushort;    // 0..65535
typedef unsigned long  ulong;     // 0..labai_daug
#endif

// maksimalios/minimalios tipu reiksmes
#define MAXSCHAR ((schar)0x7F)
#define MINSCHAR ((schar)0x80)

#ifndef MAXSHORT
#define MAXSHORT ((short)0x7FFF)
#endif
#ifndef MINSHORT
#define MINSHORT ((short)0x8000)
#endif
#ifndef MAXLONG
#define MAXLONG  ((long)0x7FFFFFFF)
#endif
#ifndef MINLONG
#define MINLONG  ((long)0x80000000)
#endif
// I FUNKCIJAS PANASUS MAKROSAI
#define MIN(x,y)   (((x) < (y)) ? (x) : (y))            // grazina mazesni
#define MAX(x,y)   (((x) > (y)) ? (x) : (y))            // grazina didesni
#define MID(x,y,z) MAX((x), MIN((y), (z)))              // grazina vidurini
#define SGN(u) ((u)>=0 ? 1:(-1))                        // grazina zenkla
#define ABS(u) ((u)>=0 ? (u):(-(u)))                    // grazina moduli
#define SWAP(aa,bb) { (aa)^=(bb); (bb)^=(aa); (aa)^=(bb); } // sukeicia

#ifndef __cplusplus
typedef enum {
        false, true
} bool;
#endif

#ifndef NULL
#define NULL 0
#endif

/** ATMINTIES **************************************************************/

#ifdef __cplusplus
#include <cstring>
#else
#include <string.h>
#endif

#define STOS(dst, val, num) memset((dst), (val), (num))
#define MOVE(dst, val, num) memcpy((dst), (val), (num))

#if (defined TGT_DOS || defined TGT_LIN)
static inline void STOS4(void *dest, long filler, long dwords)
{
        long foo;
        __asm__ __volatile__ (
                "cld   \n"
                "rep   \n"
                "stosl \n"
                : "=c"(foo), "=D"(foo)
                : "D"(dest), "a"(filler), "c"(dwords));
}
static inline void MOVE4(void *dest, void *source, long dwords)
{
        long foo;
        __asm__ __volatile__ (
                "cld   \n"
                "rep   \n"
                "movsl \n"
                : "=c"(foo), "=D"(foo), "=S"(foo)
                : "D"(dest), "S"(source), "c"(dwords));
}
static inline void MOVESTOS4(void *dest, void *source, long filler, long dwords)
{
        long foo;
        __asm__ __volatile__ (
                "0:                   \n"
                "movl  (%%esi), %%ebx \n"
                "movl  %%ebx, (%%edi) \n"
                "addl  $4, %%edi      \n"
                "movl  %%eax, (%%esi) \n"
                "addl  $4, %%esi      \n"
                "decl  %%ecx          \n"
                "jnz   0b             \n"
                : "=a"(foo), "=b"(foo), "=c"(foo), "=D"(foo), "=S"(foo)
                : "D" (dest), "S" (source), "a" (filler), "c" (dwords));
}
#else
static inline void STOS4(void *dest, long filler, long dwords)
        { memset(dest, filler, dwords*4); }
static inline void MOVE4(void *dest, void *source, long dwords)
        { memcpy(dest, source, dwords*4); }
static inline void MOVESTOS4(void *dest, void *source, long filler, long dwords)
        { MOVE4(dest, source, dwords); STOS4(dest, filler, dwords); }
#endif


/** FIXED POINT ************************************************************/

#ifndef TGT_WIN

// Fixed skaicius, 32 bitu : 1.15.16 ( zenklas, sveik.dalis, trupm.dalis )
typedef long fixed;

#define FBITS 16
#define FRAC (1<<FBITS)

#if (defined TGT_LIN || defined TGT_DOS)
static inline fixed FMUL(fixed a, fixed b)
{
        fixed result;
        asm(
            "movl %1, %0          \n" /* mov eax, (a) */
            "imull %2             \n" /* imul (b) */
            "shrdl $16, %%edx, %0 \n" /* shrd eax, edx, 16 */
        : "=&a"(result)    /* result = eax */
        : "mr"(a), "mr"(b) /* a, b = reg | mem */
        : "%edx", "%cc");  /* modify: edx, flags */
        return result;
}
static inline fixed FDIV_2(fixed a, fixed b)
{
        fixed ret;
        asm(
            "movl  %%eax,%%edx     \n" /* sitos dvi leidzia kitas */
            "sarl  $31,%%edx       \n" /* geriau ant pentiumo */
            "shldl $16,%%eax,%%edx \n"
            "sall  $16,%%eax       \n"
            "idivl %%ecx           \n"
        : "=a"(ret)
        : "a"(a), "c"(b)
        : "%edx", "%cc");
        return ret;
}
#else
// kitiem komp. kolkas l.letas
static inline fixed FMUL(fixed a, fixed b)
        { return (fixed)(((float)a * (float)b) / FRAC); }
static inline fixed FDIV_2(fixed a, fixed b)
        { return (fixed)((float)(a) * FRAC / (float)b); }
#endif

static inline fixed FDIV(fixed a, fixed b)
{
        if ((abs(a) >> 14) >= abs(b))
                return (a ^ b) < 0 ? MINLONG : MAXLONG;
        return FDIV_2(a, b);
}

#endif // TGT_WIN

/** MATEMATIKA *************************************************************/

static inline long IRSCALE(long x, long n, long d)
        { return ((x<<1) * n / d + ((x ^ n ^ d) >> 31) + 1) >> 1; }


#if defined __cplusplus
}
#endif

#endif

